package cs108;

import org.junit.jupiter.api.Test;

import java.util.*;

import static org.junit.jupiter.api.Assertions.assertEquals;
import static org.junit.jupiter.api.Assertions.assertTrue;

public class ListsTest {
    @Test
    public void testAddMultipleOccurrences() {
        List<Number> l = new ArrayList<>();
        Lists.<Double>addMultipleOccurrences(l, 3.14, 0); // 1
        assertTrue(l.isEmpty());

        Lists.<Integer>addMultipleOccurrences(l, 12, 1); // 2
        assertEquals(1, l.size());
        assertEquals(12, l.get(0));

        Lists.<Double>addMultipleOccurrences(l, 0.5, 19); // 3
        assertEquals(20, l.size());

        Iterator<Number> it = l.iterator();
        assertEquals(12, it.next());
        while (it.hasNext())
            assertEquals(0.5, it.next());

        // Invalide : on tente d'ajouter des chaînes à une liste de nombres.
        //      Lists.addMultipleOccurrences(l, "55", 1); // 4
        //        assertEquals(55, l.get(20));
    }

    @Test
    public void testCopy() {
        List<Number> ln = new ArrayList<>();
        List<Number> ln2 = new ArrayList<>();
        List<Integer> li = new ArrayList<>();
        List<Double> ld = new ArrayList<>();

        Lists.<Integer>addMultipleOccurrences(li, 1, 5);
        Lists.<Double>addMultipleOccurrences(ld, 3.14, 5);

        Lists.copy(li, ln); // 5
        assertEquals(List.of(1,1,1,1,1), ln);
        Lists.copy(ld, ln); // 6
        assertEquals(List.of(1,1,1,1,1,3.14,3.14,3.14,3.14,3.14), ln);

        Lists.<Number>copy(li, ln2); // 7
        Lists.<Integer>copy(li, ln2); // 8
        assertEquals(List.of(1,1,1,1,1,1,1,1,1,1), ln2);

        // Invalide : on tente de copier une liste de nombres (qui pourrait
        // p.ex. contenir des doubles) dans une liste d'entiers.
        //        Lists.copy(ln, li); // 9
        //        assertEquals(List.of(1,1,1,1,1,1,1,1,1,1,3.14,3.14,3.14,3.14,3.14), li);

        // Invalide : on tente de copier une liste de nombres (qui pourrait
        // p.ex. contenir des entiers) dans une liste de doubles.
        //        Lists.copy(ln, ld); // 10
        //        assertEquals(List.of(3.14,3.14,3.14,3.14,3.14,1,1,1,1,1,3.14,3.14,3.14,3.14,3.14), ld);
    }

    @Test
    public void testMax() {
        Comparator<Number> numComparator = Comparator.comparingDouble(Number::doubleValue);
        List<Integer> li = List.of(1, 2, 3);
        int max = Lists.max(li, numComparator); // 11
        assertEquals(3, max);

        Number max2 = Lists.<Number>max(li, numComparator); // 12
        assertEquals(3, max2);

        // Invalide : étant donné que l'on force T à être Object, le comparateur
        // (qui ne sait que comparer des nombres) ne peut être utilisé ici.
        //        Object max3 = Lists.<Object>max(li, numComparator); // 13
        //        assertEquals(3, max3);
    }
}
